unit Unit1;

{$IFDEF WIN32}
{$APPTYPE Console}
{$ENDIF}

{$MODE objfpc}{$H+}

(*
Es gibt 2 Möglichkeiten eine Library ein zu binden.

der Kompilerswitch zeigt die eine, oder die andere.

bei usedynbinding mus die Library nicht in

/usr/lib/

stehen.


Will Man Informationen über eine DLL herausbekommen geht das mittels

Anzeigen aller Export Namen und Abhänngigkeiten :
objdump -x <Libname>

Anzeigen ob die Abhängigkeiten aufgelöst werden können :
ldd <Libname>

*)
{$DEFINE usedynbinding}

interface

uses
  Classes, SysUtils, FileUtil, LResources, Forms, Controls, Graphics, Dialogs,
  StdCtrls
{$IFDEF usedynbinding}
  , dynlibs
{$ENDIF}
  ;

type

  { TForm1 }

  TForm1 = class(TForm)
    Button1: TButton;
    procedure Button1Click(Sender: TObject);
  private
    { private declarations }
  public
    { public declarations }
  end;

var
  Form1: TForm1;

{$IFDEF usedynbinding}
type
  TShowm = procedure(Value: PChar);
var
  tmpString: string; // Kein Bock gehabt auf Procedure, zu kompliziert wegen der Kompilerswitches
  lib: TLibHandle = 0;
  Showm: TShowm = nil;
{$ELSE}
  (*
  Damit dies hier funktioniert dann mus die "libdemo.so" im

  /usr/lib/

  Verzeichnis liegen.

  Ist dies nicht der Fall, gibt es einen Linker Fehler
  *)

procedure Showm(Value: PChar); external{$IFDEF Win32} 'libdemo.dll'{$ELSE} 'libdemo.so'{$ENDIF}; {cdecl; -- Mus zum einbinden von C Libs rein !!}
{$ENDIF}

implementation

{$R *.lfm}

{ TForm1 }

procedure TForm1.Button1Click(Sender: TObject);
var
  s: string;
begin
  s := 'Hello World';
  (*
   * Achtung Showm schreibt auf die Console, ..
   *)
  Showm(@s[1]);
end;

{$IFDEF usedynbinding}

initialization
  tmpString := IncludeTrailingBackslash(ExtractFilePath(Paramstr(0))) + {$IFDEF Win32} 'libdemo.dll'{$ELSE} 'libdemo.so'{$ENDIF};
  lib := LoadLibrary(tmpString);
  if lib = 0 then
    raise exception.create('Error could not init Library');
  Showm := TShowm(GetProcAddress(lib, 'Showm'));
  if not assigned(Showm) then
    raise exception.create('Error could not load Method in Library');

finalization

  if Lib <> 0 then
    UnloadLibrary(lib);
{$ENDIF}
end.
